
MakeE                   LD   DE,#4000
                        LD   HL,ScreenTable
                        LD   C,24

MakeE1                  LD   B,8

MakeE2                  LD   (HL),E
                        INC  H
                        LD   (HL),D
                        DEC  H
                        INC  L
                        INC  D
                        DJNZ MakeE2

                        LD   A,E
                        ADD  A,32
                        LD   E,A
                        JR   C,MakeE3

                        LD   A,D
                        SUB  8
                        LD   D,A

MakeE3                  DEC  C
                        JR   NZ,MakeE1

                        RET

Point                   LD   A,E
                        ADD  A,#60
                        LD   H,0
                        RET  Z
                        CP   191
                        RET  NC
                        LD   E,A
                        LD   A,D
                        ADD  A,#60
                        RET  Z
                        CP   191
                        RET  NC
                        LD   D,A
                        PUSH BC
                        LD   A,E
                        AND  7
                        LD   L,A
                        LD   B,H
                        LD   H,high Bits
                        LD   A,(HL)
                        LD   H,high ScreenTable
                        LD   L,D
                        LD   C,(HL)
                        INC  H
                        LD   H,(HL)
                        LD   L,C
                        LD   C,E
                        SRL  C
                        SRL  C
                        SRL  C
                        ADD  HL,BC
                        POP  BC
                        RET

ClrScr                  LD   HL,#4000
                        LD   DE,#4001
                        LD   BC,#17FF
                        LD   (HL),0
                        LDIR
                        RET

Attrib                  LD   HL,#5800
                        LD   DE,#5801
                        LD   BC,#2FF
                        LD   (HL),A
                        LDIR

                        RRA
                        RRA
                        RRA

                        AND 7

                        OUT  (#FE),A
                        RET

DrawScreenBorder        LD   DE,#BF00
                        LD   H,E
                        LD   L,E
                        LD   C,7
                        CALL Line

                        LD   HL,#00BF
                        LD   D,L
                        LD   E,L
                        CALL Line

                        LD   DE,#00BF
                        LD   H,D
                        LD   L,D
                        CALL Line

                        LD   HL,#BF00
                        LD   D,H
                        LD   E,H
                        CALL Line

                        LD   HL,#5800
                        LD   DE,#5820
                        LD   BC,#2E0
                        LDIR
                        RET

Scaner                  LD   HL,#4F1A
                        LD   E,1
                        LD   B,1
                        LD   C,41
Scan1                   PUSH HL
                        DEC  E
                        JR   Z,Scan2
                        LD   (HL),#01
                        INC  L
                        LD   (HL),#01
                        INC  L
                        LD   (HL),#01
                        INC  L
                        LD   (HL),#01
                        INC  L
                        LD   (HL),#01
                        INC  L
                        LD   (HL),#01
                        JR   Scan3
Scan2                   LD   (HL),#01
                        INC  L
                        LD   (HL),#FF
                        INC  L
                        LD   (HL),#FF
                        INC  L
                        LD   (HL),#FF
                        INC  L
                        LD   (HL),#FF
                        INC  L
                        LD   (HL),#FF
                        LD   E,8
Scan3                   POP  HL
                        INC  H
                        DJNZ Scan4
                        LD   B,8
                        LD   A,L
                        ADD  A,32
                        LD   L,A
                        LD   A,H
                        SUB  8
                        LD   H,A
Scan4                   DEC  C
                        JR   NZ,Scan1
                        LD   HL,#593B
                        LD   DE,#593C
                        LD   (HL),7
                        LD   BC,4
                        LDIR
                        LD   HL,#043B
Scan5                   PUSH HL
                        LD   A,E
                        ADD  A,#1B
                        LD   E,A
                        LD   H,D
                        LD   C,5
                        LDIR
                        POP  HL
                        DEC  H
                        JR   NZ,Scan5
                        RET

EnFilt                  LD   HL,#CF74
                        LD   DE,#CF97
                        LD   C,#7
                        CALL Line
                        LD   HL,#FF74
                        LD   DE,#FF97
                        CALL Line
                        LD   HL,#0574
EnFil1                  PUSH HL
                        LD   D,#FE
                        LD   H,#D0
                        LD   E,L
                        CALL Line
                        POP  HL
                        LD   A,L
                        ADD  A,7
                        LD   L,A
                        DEC  H
                        JR   NZ,EnFil1
                        LD   D,#FE
                        LD   H,#D0
                        LD   E,L
                        LD   C,#17
                        CALL Line
                        JP   EnWord

Shield                  LD   HL,#411A
                        LD   B,7
                        LD   C,46
Shiel1                  PUSH HL
                        LD   (HL),#80
                        INC  L
                        LD   (HL),0
                        INC  L
                        LD   (HL),0
                        INC  L
                        LD   (HL),0
                        INC  L
                        LD   (HL),0
                        INC  L
                        LD   (HL),1
                        POP  HL
                        INC  H
                        DJNZ Shiel2
                        LD   B,8
                        LD   A,L
                        ADD  A,32
                        LD   L,A
                        LD   A,H
                        SUB  8
                        LD   H,A
Shiel2                  DEC  C
                        JR   NZ,Shiel1
                        LD   HL,#413A
                        LD   DE,tShiOn
                        LD   C,7
Shiel3                  LD   B,6
                        PUSH HL
Shiel4                  LD   A,(DE)
                        XOR  (HL)
                        LD   (HL),A
                        INC  DE
                        INC  L
                        DJNZ Shiel4
                        POP  HL
                        INC  H
                        DEC  C
                        JR   NZ,Shiel3
                        LD   HL,#417C
                        LD   B,7
Shiel5                  PUSH HL
                        LD   A,(DE)
                        XOR  (HL)
                        LD   (HL),A
                        INC  DE
                        INC  L
                        LD   A,(DE)
                        XOR  (HL)
                        LD   (HL),A
                        INC  DE
                        POP  HL
                        INC  H
                        DJNZ Shiel5
                        RET

ShFlsh                  LD   HL,#583B
                        LD   B,4
ShFls1                  LD   A,(HL)
                        XOR  7
                        LD   (HL),A
                        INC  L
                        DJNZ ShFls1
                        LD   HL,#587C
                        LD   A,(HL)
                        XOR  7
                        LD   (HL),A
                        INC  L
                        LD   A,(HL)
                        XOR  7
                        LD   (HL),A
                        LD   DE,#413A
                        LD   HL,tShiOn
                        LD   BC,6

                        loop 6
                          LD   A,(DE)
                          XOR  (HL)
                          LD   (DE),A
                          INC  D
                          ADD  HL,BC
                          lend

                        LD   A,(DE)
                        XOR  (HL)
                        LD   (DE),A

                        LD   DE,#413F
                        LD   HL,tShiOn+5

                        loop 6
                          LD   A,(DE)
                          XOR  (HL)
                          LD   (DE),A
                          ADD  HL,BC
                          INC  D
                          lend

                        LD   A,(DE)
                        XOR  (HL)
                        LD   (DE),A
                        RET

Lights                  LD   IX,#4979
                        LD   B,6
                        LD   A,#7E

Light1                  LD   (IX-64),A
                        LD   (IX-32),A
                        LD   (IX),A
                        LD   (IX+32),A
                        LD   (IX+64),A
                        INC  HL
                        INC  IXH
                        DJNZ Light1

                        LD   A,Lmp12a
                        LD   (Lamp1),A
                        LD   (Lamp2),A

                        XOR  A
                        LD   (dmpfwd),A
                        LD   (dmpang),A

                        LD   A,Lmp34b
                        LD   (Lamp3),A

                        LD   A,Lmp34a
                        LD   (Lamp4),A

                        XOR  A
                        LD   (shstat),A

                        LD   A,Lmp5a
                        LD   (Lamp5),A

                        LD   A,2
                        LD   (condition),A

                        RET

mStoreAtHL_IncL         macro(val)
                          LD   (HL),val
                          INC  L
                          mend

LScanr                  LD   HL,#401A
                        LD   BC,48

LScan1                  mStoreAtHL_IncL(#80)
                        mStoreAtHL_IncL(B)
                        mStoreAtHL_IncL(B)
                        mStoreAtHL_IncL(B)
                        mStoreAtHL_IncL(B)
                        LD   (HL),1

                        LD   A,L
                        SUB  5
                        LD   L,A

                        INC  H

                        LD   A,C
                        DEC  A
                        AND  7
                        JR   NZ,LScan2

                        LD   A,H
                        SUB  8
                        LD   H,A

                        LD   A,L
                        ADD  A,32
                        LD   L,A

LScan2                  DEC  C
                        JR   NZ,LScan1
                        LD   HL,#581A
                        LD   BC,#607
LScan3                  mStoreAtHL_IncL(C)
                        mStoreAtHL_IncL(C)
                        mStoreAtHL_IncL(C)
                        mStoreAtHL_IncL(C)
                        mStoreAtHL_IncL(C)
                        LD   (HL),C

                        LD   DE,27
                        ADD  HL,DE
                        DJNZ LScan3

                        LD   A,#FF
                        LD   HL,#401A

                        mStoreAtHL_IncL(A)
                        mStoreAtHL_IncL(A)
                        mStoreAtHL_IncL(A)
                        mStoreAtHL_IncL(A)
                        mStoreAtHL_IncL(A)
                        LD   (HL),A
                        LD   HL,#47BA
                        mStoreAtHL_IncL(A)
                        mStoreAtHL_IncL(A)
                        mStoreAtHL_IncL(A)
                        mStoreAtHL_IncL(A)
                        mStoreAtHL_IncL(A)
                        LD   (HL),A
                        RET

VelInd                  LD   HL,#F00F
                        LD   (#4018),HL
                        LD   (#4A18),HL

                        LD   HL,#C401
                        LD   DE,#C441
                        LD   C,#7
                        CALL Line

                        LD   HL,#CB01
                        LD   DE,#CB41
                        CALL Line

                        LD   HL,#1818
                        LD   (#40D8),HL
                        LD   (#41D8),HL

                        LD   DE,#43FA
                        LD   HL,#4000
                        LD   BC,6
                        LDIR

                        LD   DE,#4A1A
                        LD   C,6
                        LDIR

                        LD   HL,#D03C
                        LD   DE,#D041
                        LD   C,#7
                        CALL Line

                        LD   HL,#FF3C
                        LD   DE,#FF41
                        CALL Line

                        LD   HL,#8001
                        LD   (#42FC),HL
                        LD   (#4B1C),HL
                        RET

ShCOn                   LD   HL,#42DB
                        LD   DE,tShCOn
                        LD   C,6
ShCOn1                  LD   B,4
                        PUSH HL
ShCOn2                  LD   A,(DE)
                        LD   (HL),A
                        INC  DE
                        INC  L
                        DJNZ ShCOn2
                        POP  HL
                        INC  H
                        DEC  C
                        JR   NZ,ShCOn1
                        LD   HL,#58DB
                        LD   DE,#58DC
                        LD   BC,3
                        LD   (HL),4
                        LDIR
                        RET

ShCOff                  LD   HL,#42DB
                        LD   DE,tShCOf
                        LD   C,6
ShCOf1                  LD   B,4
                        PUSH HL
ShCOf2                  LD   A,(DE)
                        LD   (HL),A
                        INC  DE
                        INC  L
                        DJNZ ShCOf2
                        POP  HL
                        INC  H
                        DEC  C
                        JR   NZ,ShCOf1
                        LD   HL,#58DB
                        LD   DE,#58DC
                        LD   BC,3
                        LD   (HL),3
                        LDIR
                        RET

ShCAut                  LD   HL,#42DB
                        LD   DE,tShCAu
                        LD   C,6
ShCAu1                  LD   B,4
                        PUSH HL
ShCAu2                  LD   A,(DE)
                        LD   (HL),A
                        INC  DE
                        INC  L
                        DJNZ ShCAu2
                        POP  HL
                        INC  H
                        DEC  C
                        JR   NZ,ShCAu1
                        LD   HL,#58DB
                        LD   DE,#58DC
                        LD   BC,3
                        LD   (HL),5
                        LDIR
                        RET

EnWord                  LD   HL,#4CD8
                        LD   B,4
                        LD   C,35
                        LD   DE,tEnWd
EnWd1                   LD   A,(DE)
                        XOR  (HL)
                        LD   (HL),A
                        INC  L
                        INC  DE
                        LD   A,(DE)
                        XOR  (HL)
                        LD   (HL),A
                        DEC  L
                        INC  DE
                        INC  H
                        DJNZ EnWd2
                        LD   B,8
                        LD   A,L
                        ADD  A,32
                        LD   L,A
                        JR   C,EnWd2
                        LD   A,H
                        SUB  8
                        LD   H,A
EnWd2                   DEC  C
                        JR   NZ,EnWd1
                        RET

ScWord                  LD   HL,#51F8
                        LD   DE,tScWd
                        LD   C,7
ScWd1                   PUSH HL
                        LD   B,4
ScWd2                   LD   A,(DE)
                        INC  DE
                        LD   (HL),A
                        INC  L
                        DJNZ ScWd2
                        POP  HL
                        INC  H
                        DEC  C
                        JR   NZ,ScWd1
                        RET

ScDisp                  LD   HL,scdel
                        DEC  (HL)
                        RET  NZ
                        LD   (HL),ScDel
                        LD   A,(scctr)
                        OR   A
                        JR   NZ,ScDOld
ScDNew                  LD   HL,(score)
                        LD   DE,(scodis)
                        SBC  HL,DE
                        RET  Z
                        LD   A,E
                        ADD  A,1
                        DAA
                        LD   E,A
                        LD   A,D
                        ADC  A,0
                        DAA
                        LD   D,A
                        LD   (scodis),DE
                        LD   A,7
                        LD   (scctr),A
                        LD   HL,scdig1
                        LD   A,10
ScDN1                   INC  (HL)
                        CP   (HL)
                        JR   NZ,ScDOld
                        LD   (HL),0
                        INC  HL
                        JR   ScDN1
ScDOld                  LD   HL,#51FF
                        LD   DE,scdig1
ScDO1                   PUSH DE
                        PUSH HL
                        LD   A,(DE)
                        ADD  A,A
                        ADD  A,A
                        ADD  A,A
                        LD   E,A
                        LD   D,0
                        LD   HL,NumSet
                        ADD  HL,DE
                        LD   A,(scctr)
                        NEG
                        ADD  A,7
                        LD   E,A
                        ADD  HL,DE
                        LD   C,(HL)
                        POP  HL
                        PUSH HL
                        LD   D,H
                        LD   E,L
                        INC  D
                        LD   B,6
ScDO2                   LD   A,(DE)
                        LD   (HL),A
                        INC  D
                        INC  H
                        DJNZ ScDO2
                        LD   (HL),C
                        POP  HL
                        POP  DE
                        LD   A,(DE)
                        DEC  L
                        INC  DE
                        OR   A
                        JR   Z,ScDO1
                        LD   A,(scctr)
                        DEC  A
                        LD   (scctr),A
                        RET

DisVel                  LD   HL,dvdel
                        DEC  (HL)
                        RET  NZ

                        LD   (HL),DVDel
                        LD   A,(disav)
                        LD   C,A

                        LD   A,(velang)
                        CP   C
                        JR   Z,DisV3

                        LD   HL,(disaad)
                        LD   DE,(disamk)
                        CALL DisVa

                        LD   A,(velang)
                        LD   (disav),A

                        BIT  7,A
                        JR   Z,DisV0

                        NEG
                        SRA  A
                        SRA  A
                        CPL
                        ADD  A,24
                        JR   DisV0a

DisV0                   SRA  A
                        SRA  A

                        ADD  A,23

DisV0a                  LD   HL,Bits
                        LD   E,A
                        AND  7
                        add a,l
                        ld l,a
                        LD   D,(HL)

                        LD   A,E
                        RRA
                        RRA
                        RRA
                        AND  7
                        LD   C,A
                        ld B,0

                        LD   HL,#44FA
                        ADD  HL,BC
                        LD   A,D
                        RRCA
                        JR   C,DisV1

                        LD   E,0
                        OR   D
                        LD   D,A
                        JR   DisV2

DisV1                   LD   E,A

DisV2                   CALL DisVa

DisV3                   LD   HL,(disfv)
                        LD   DE,(velfwd)
                        OR   A
                        SBC  HL,DE
                        RET  Z

                        LD   HL,(disfa1)
                        LD   DE,(disfa2)
                        CALL DisVf

                        LD   HL,(velfwd)
                        LD   (disfv),HL

                        LD   A,96
                        SUB  L
                        SRL  A
                        LD   L,A
                        LD   H,high ScreenTable
                        LD   C,#18
                        LD   A,(HL)
                        ADD  A,C
                        LD   E,A
                        INC  H
                        LD   D,(HL)
                        DEC  H
                        INC  L
                        LD   A,(HL)
                        ADD  A,C
                        INC  H
                        LD   H,(HL)
                        LD   L,A
                        LD   (disfa1),HL
                        LD   (disfa2),DE
                        CALL DisVf
                        RET

DisVa                   LD   B,4
                        LD   C,6
                        LD   (disaad),HL
                        LD   (disamk),DE
DisVa1                  LD   A,(HL)
                        XOR  D
                        LD   (HL),A
                        INC  L
                        LD   A,(HL)
                        XOR  E
                        LD   (HL),A
                        DEC  L
                        INC  H
                        DJNZ DisVa2
                        LD   A,L
                        ADD  A,32
                        LD   L,A
DisVa2                  DEC  C
                        JR   NZ,DisVa1
                        RET

DisVf                   LD   A,(HL)
                        XOR  7
                        LD   (HL),A
                        INC  L
                        LD   A,(HL)
                        XOR  #E0
                        LD   (HL),A
                        LD   A,(DE)
                        XOR  7
                        LD   (DE),A
                        INC  E
                        LD   A,(DE)
                        XOR  #E0
                        LD   (DE),A
                        RET

EnDisp                  LD   HL,enddel
                        DEC  (HL)
                        RET  NZ
                        LD   (HL),EnDDel
                        LD   A,(endisp)
                        LD   D,A
                        LD   A,(energy)
                        CP   D
                        RET  Z
                        JR   C,EnDDec
                        INC  D
                        LD   A,D
                        LD   (endisp),A
                        JP   EnDis0

EnDDec                  LD   A,D
                        DEC  A
                        LD   (endisp),A
EnDis0                  LD   HL,tEnDR
                        DEC  D
EnDis1                  LD   A,D
                        SUB  47
                        JR   C,EnDis2
                        LD   D,A
                        INC  HL
                        INC  HL
                        JP   EnDis1

EnDis2                  LD   A,(HL)
                        INC  HL
                        LD   H,(HL)
                        LD   L,A
                        PUSH HL
                        LD   HL,Bits
                        LD   A,D
                        AND  7
                        LD   B,0
                        LD   C,A
                        ADD  HL,BC
                        LD   E,(HL)
                        LD   A,D
                        RRA
                        RRA
                        RRA
                        AND  7
                        POP  HL
                        LD   C,A
                        ADD  HL,BC
                        LD   B,4
EnDis3                  LD   A,(HL)
                        XOR  E
                        LD   (HL),A
                        INC  H
                        LD   A,H
                        AND  7
                        JP   NZ,EnDis4
                        LD   A,L
                        ADD  A,32
                        LD   L,A
                        JR   C,EnDis4
                        LD   A,H
                        SUB  8
                        LD   H,A
EnDis4                  DJNZ EnDis3
                        RET

ScLfRt                  LD   HL,slrdel
                        DEC  (HL)
                        RET  NZ
                        LD   (HL),SlrDel
                        LD   A,(slrflg)
                        OR   A
                        JR   NZ,ScLR2
                        LD   A,(slrfre)
                        OR   A
                        JR   Z,SlrMov
                        DEC  A
                        LD   (slrfre),A
                        JR   SlrMov

ScLR2                   CALL SlrDo
                        RET  NC
                        XOR  A
                        LD   (slrflg),A
                        LD   A,60
                        LD   (slrfre),A
                        JR   SlrMov
SlrDo                   LD   A,(slrctr)
                        DEC  A
                        JR   Z,SlrDNx
                        LD   (slrctr),A
SlrMov                  LD   C,7
                        LD   DE,slrbuf
                        LD   HL,#51DF
SlrM1                   LD   A,(DE)
                        SLA  A
                        LD   (DE),A
                        INC  DE

                        loop 7
                          RL   (HL)
                          DEC  L
                          lend

                        LD   A,(HL)
                        RLA
                        AND  #F
                        LD   (HL),A
                        LD   L,#DF
                        INC  H
                        DEC  C
                        JR   NZ,SlrM1
                        RET

SlrDNx                  LD   HL,(slrptr)
                        LD   A,(HL)
                        OR   A
                        SCF
                        RET  Z

                        INC  HL
                        LD   (slrptr),HL
                        LD   DE,ChSet
                        ADD  A,A
                        LD   L,A
                        LD   H,0
                        ADD  HL,HL
                        ADD  HL,HL
                        ADD  HL,DE
                        LD   DE,slrbuf
                        LD   BC,7
                        LDIR

                        LD   A,6
                        LD   (slrctr),A
                        JR   SlrMov

ScLRIn                  PUSH HL
                        LD   HL,slrfre
                        CP   (HL)
                        POP  HL
                        RET  C
                        LD   A,(slrflg)
                        OR   A
                        SCF
                        RET  NZ
                        LD   (slrptr),HL
                        LD   A,1
                        LD   (slrflg),A
                        LD   (slrctr),A
                        OR   A
                        RET

ScUpDn                  LD   HL,suddel
                        DEC  (HL)
                        RET  NZ
                        LD   (HL),SudDel
                        LD   A,(sudctr)
                        OR   A
                        JR   NZ,ScUD1
                        LD   A,(sudfre)
                        OR   A
                        RET  Z
                        DEC  A
                        LD   (sudfre),A
                        RET

ScUD1                   DEC  A
                        LD   (sudctr),A
                        JR   NZ,ScUD8
                        LD   A,(sudrct)
                        DEC  A
                        LD   (sudrct),A
                        JR   NZ,ScUD2
                        LD   A,100
                        LD   (sudfre),A
                        RET

ScUD2                   LD   HL,sudbuf
                        LD   DE,sudbuf+1
                        LD   BC,55
                        LD   (HL),0
                        LDIR
                        LD   DE,sudbuf
                        LD   B,10
                        LD   HL,(sudptr)
                        LD   A,4
ScUD3                   PUSH BC
                        LD   C,(HL)
                        INC  HL
                        PUSH HL
                        LD   L,C
                        LD   H,0
                        ADD  HL,HL
                        ADD  HL,HL
                        ADD  HL,HL
                        LD   BC,ChSet
                        ADD  HL,BC
                        LD   B,7
                        LD   C,A
                        PUSH DE
ScUD4                   PUSH BC
                        LD   A,(HL)
                        LD   B,0
                        INC  C
ScUD5                   DEC  C
                        JR   Z,ScUD6
                        SRL  A
                        RR   B
                        JR   ScUD5
ScUD6                   LD   C,A
                        LD   A,(DE)
                        OR   C
                        LD   (DE),A
                        INC  DE
                        LD   A,(DE)
                        OR   B
                        LD   (DE),A
                        LD   BC,7
                        EX   DE,HL
                        ADD  HL,BC
                        EX   DE,HL
                        POP  BC
                        INC  HL
                        DJNZ ScUD4
                        POP  DE
                        LD   A,C
                        ADD  A,6
                        LD   C,A
                        AND  7
                        CP   C
                        JR   Z,ScUD7
                        INC  DE
ScUD7                   POP  HL
                        POP  BC
                        DJNZ ScUD3
                        LD   (sudptr),HL
                        LD   A,7
                        LD   (sudctr),A
ScUD8                   LD   DE,#5478
                        LD   HL,#5578
                        LD   B,20
ScUD9                   PUSH BC
                        LD   BC,8
                        LDIR
                        INC  D
                        INC  H
                        LD   A,E
                        SUB  8
                        LD   E,A
                        LD   A,L
                        SUB  8
                        LD   L,A
                        LD   A,D
                        AND  7
                        JR   NZ,ScUD10
                        LD   A,D
                        SUB  8
                        LD   D,A
                        LD   A,E
                        ADD  A,32
                        LD   E,A
                        JR   ScUD11
ScUD10                  LD   A,H
                        AND  7
                        JR   NZ,ScUD11
                        LD   A,H
                        SUB  8
                        LD   H,A
                        LD   A,L
                        ADD  A,32
                        LD   L,A
ScUD11                  POP  BC
                        DJNZ ScUD9
                        LD   HL,sudbuf
                        LD   C,8
                        LDIR
                        LD   DE,sudbuf
                        LD   C,48
                        LDIR
                        RET

ScUDIn                  EXX
                        LD   HL,sudfre
                        CP   (HL)
                        RET  C
                        LD   A,(sudctr)
                        OR   A
                        SCF
                        RET  NZ
                        LD   A,1
                        LD   (sudctr),A
                        EXX
                        LD   (sudptr),HL
                        LD   A,4
                        LD   (sudrct),A
                        RET

Knackd                  LD   HL,kncctr
                        DEC  (HL)
                        RET  NZ
                        LD   (HL),6
                        LD   A,(kncptr)
                        LD   E,A
                        LD   D,$22                      ; Source of randomness
                        LD   HL,#411A
                        LD   C,46
Knack1                  PUSH HL
                        LD   A,(DE)
                        OR   #80
                        LD   (HL),A
                        INC  E
                        INC  L
                        LD   A,(DE)
                        LD   (HL),A
                        INC  E
                        INC  L
                        LD   A,(DE)
                        LD   (HL),A
                        INC  E
                        INC  L
                        LD   A,(DE)
                        LD   (HL),A
                        INC  E
                        INC  L
                        LD   A,(DE)
                        LD   (HL),A
                        INC  E
                        INC  L
                        LD   A,(DE)
                        OR   #01
                        LD   (HL),A
                        INC  E
                        POP  HL
                        INC  H
                        LD   A,H
                        AND  7
                        JR   NZ,Knack3
                        LD   A,L
                        ADD  A,32
                        LD   L,A
                        LD   H,#40
Knack3                  DEC  C
                        JR   NZ,Knack1
                        LD   A,R
                        ADD  A,E
                        LD   (kncptr),A
                        LD   HL,#483B
                        LD   C,5
Knack4                  LD   B,7
Knack5                  PUSH HL
                        LD   A,(DE)
                        OR   1
                        LD   (HL),A
                        INC  L
                        INC  E
                        LD   A,(DE)
                        OR   1
                        LD   (HL),A
                        INC  L
                        INC  E
                        LD   A,(DE)
                        OR   1
                        LD   (HL),A
                        INC  L
                        INC  E
                        LD   A,(DE)
                        OR   1
                        LD   (HL),A
                        INC  L
                        INC  E
                        LD   A,(DE)
                        OR   1
                        LD   (HL),A
                        INC  L
                        INC  E
                        POP  HL
                        INC  H
                        DJNZ Knack5
                        LD   H,#48
                        LD   A,L
                        ADD  A,32
                        LD   L,A
                        DEC  C
                        JR   NZ,Knack4
                        RET

KnacAt                  LD   HL,#581A
                        LD   BC,#0607

KnacA1                  LD   (HL),C
                        INC  L
                        LD   (HL),C
                        INC  L
                        LD   (HL),C
                        INC  L
                        LD   (HL),C
                        INC  L
                        LD   (HL),C
                        INC  L
                        LD   (HL),C
                        LD   A,L
                        ADD  A,#1B
                        LD   L,A
                        DJNZ KnacA1

                        LD   HL,#401A
                        LD   BC,#02FF

KnacA2                  LD   (HL),C
                        INC  L
                        LD   (HL),C
                        INC  L
                        LD   (HL),C
                        INC  L
                        LD   (HL),C
                        INC  L
                        LD   (HL),C
                        INC  L
                        LD   (HL),C
                        LD   HL,#47BA
                        DJNZ KnacA2

                        LD   A,Lmp34c
                        LD   (Lamp3),A
                        LD   (Lamp4),A
                        RET


