; Show the player's ship

PutPly                  LD   IX,tInDef          ; A buffer
                        LD   BC,ShipShape       ; The ship's sprite
                        LD   HL,0               ; X
                        LD   DE,0               ; Y
                        LD   (IX+dX),HL         ; X
                        LD   (IX+dY),DE         ; Y
                        LD   (IX+dSpritePtr),BC ; Shape
                        JP DrawSprite           ; Draw it

; Move the player

PlyMov                  LD   A,(velang)
                        OR   A
                        JP   M,PlyM1

                        LD   E,0
                        JR   PlyM2

PlyM1                   NEG

                        LD   E,1

PlyM2                   RRA
                        RRA
                        AND  #3F
                        LD   (angle),A

                        LD   A,E
                        LD   (angsig),A

PlyM2a                  LD   A,(velfwd)
                        LD   L,A
                        LD   H,0
                        RLA
                        JR   NC,PlyM3
                        LD   H,#FF
PlyM3                   ADD  HL,HL
                        ADD  HL,HL
                        ADD  HL,HL
                        LD   (fwdmov),HL
                        LD   A,(kP)
                        CP   1
                        JR   NZ,PlyM11
                        LD   (dmpfwd),A
                        LD   A,Lmp12b
                        LD   (Lamp1),A
                        JR   PlyM12
PlyM11                  LD   A,(kO)
                        CP   1
                        JR   NZ,PlyM12
                        LD   A,Lmp12a
                        LD   (Lamp1),A
                        XOR  A
                        LD   (dmpfwd),A
PlyM12                  LD   A,(kEnt)
                        CP   1
                        JR   NZ,PlyM13
                        LD   (dmpang),A
                        LD   A,Lmp12b
                        LD   (Lamp2),A
                        JR   PlyM14
PlyM13                  LD   A,(kL)
                        CP   1
                        JR   NZ,PlyM14
                        LD   A,Lmp12a
                        LD   (Lamp2),A
                        XOR  A
                        LD   (dmpang),A
PlyM14                  LD   A,(kS)
                        CP   1
                        JR   NZ,PlyM15
                        LD   A,(shcomm)
                        OR   A
                        JR   Z,PlyM17
                        CALL ShCOff
                        XOR  A
                        LD   (shcomm),A
                        JR   PlyM17
PlyM15                  LD   A,(kD)
                        CP   1
                        JR   NZ,PlyM16
                        LD   A,(shcomm)
                        CP   1
                        JR   Z,PlyM17
                        CALL ShCOn
                        LD   A,1
                        LD   (shcomm),A
                        JR   PlyM17
PlyM16                  LD   A,(kA)
                        CP   1
                        JR   NZ,PlyM17
                        LD   A,(shcomm)
                        CP   2
                        JR   Z,PlyM17
                        CALL ShCAut
                        LD   A,2
                        LD   (shcomm),A
PlyM17                  LD   A,(k1)
                        BIT  0,A
                        JR   NZ,PlyM18
                        LD   A,(energy)
                        SUB  2
                        JR   C,PlyM18
                        LD   (energy),A
PlyM18                  LD   A,(k2)
                        RRA
                        JR   C,PlyM19
                        LD   HL,(score)
                        LD   A,L
                        ADD  A,1
                        DAA
                        LD   L,A
                        LD   A,H
                        ADC  A,0
                        DAA
                        LD   H,A
                        LD   (score),HL
PlyM19                  LD   A,(k4)
                        RRA
                        JR   C,PlyM20
                        LD   HL,Love
                        LD   A,30
                        CALL ScLRIn
PlyM20                  LD   A,(kF)
                        CP   1
                        JR   NZ,PlyM21
                        LD   HL,Love2
                        LD   A,0
                        CALL ScUDIn
PlyM21                  LD   A,(kG)
                        CP   1
                        JR   NZ,PlyM22
                        LD   HL,Blnk
                        LD   A,0
                        CALL ScUDIn
PlyM22                  LD   A,(k3)
                        RRA
                        JR   C,PlyM23
                        LD   A,2
                        LD   (shstat),A
                        CALL KnacAt
                        JR   PlyM24
PlyM23                  LD   A,(shstat)
                        CP   2
                        JR   NZ,PlyM24
                        LD   A,3
                        LD   (shstat),A
                        CALL Scaner
                        CALL LScanr
                        LD   A,Lmp34b
                        LD   (Lamp3),A
                        LD   A,Lmp34a
                        LD   (Lamp4),A
PlyM24                  RET

; Change the velocity

ChngeV                  LD   A,(kZ)
                        RRA
                        JR   NC,CV3

                        LD   A,(kX)
                        RRA
                        JR   NC,CV2

                        LD   A,(dmpang)
                        RRA
                        JR   NC,CV5

                        LD   A,(velang)
                        OR   A
                        JR   Z,CV5

                        BIT  7,A
                        JR   NZ,CV1

                        DEC  A
                        JR   CV4

CV1                     INC  A
                        JR   CV4


CV2                     LD   A,(velang)
                        ADD  A,2
                        JP   M,CV4

                        CP   MaxAngularVelocity+1
                        JR   C,CV4

                        LD   A,MaxAngularVelocity
                        JR   CV4

CV3                     LD   A,(kX)
                        RRA
                        JR   NC,CV5

                        LD   A,(velang)
                        SUB  2
                        JP   P,CV4

                        CP   -MaxAngularVelocity
                        JR   NC,CV4

                        LD   A,-MaxAngularVelocity
CV4                     LD   (velang),A

CV5                     LD   A,(kM)
                        RRA
                        JR   NC,CV8

                        LD   A,(kN)
                        RRA
                        JR   NC,CV7

                        LD   A,(dmpfwd)
                        RRA
                        JR   NC,CV10

                        LD   A,(velfwd)
                        OR   A
                        JR   Z,CV10

                        BIT  7,A
                        JR   NZ,CV6

                        DEC  A
                        JR   CV9

CV6                     INC  A
                        JR   CV9

CV7                     LD   A,(velfwd)
                        ADD  A,2
                        JP   M,CV9

                        CP   MaxForwardSpeed+1
                        JR   C,CV9

                        LD   A,MaxForwardSpeed
                        JR   CV9

CV8                     LD   A,(kN)
                        RRA
                        JR   NC,CV10

                        LD   A,(velfwd)
                        SUB  2
                        JP   P,CV9

                        CP   -MaxBackwardSpeed
                        JR   NC,CV9

                        LD   A,-MaxBackwardSpeed
CV9                     LD   (velfwd),A

CV10                    RET


